package org.rcisoft.bus.jnsp7xtm.controller;


/*固定导入*/

import cn.afterturn.easypoi.excel.entity.params.ExcelExportEntity;
import cn.hutool.core.util.ObjectUtil;
import io.swagger.annotations.ApiOperation;
import org.rcisoft.bus.jnsp7xtm.dao.Jnsp7xtmRepository;
import org.rcisoft.bus.jnsp7xtm.entity.*;
import org.rcisoft.bus.jnsp7xtm.service.Jnsp7xtmDtoService;
import org.rcisoft.bus.jnsp7xtm.service.impl.ExportExcelService;
import org.rcisoft.bus.jnsp7xtm.vo.QueryJnsp7xtmDto;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.exception.CyServiceException;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.rcisoft.core.util.CyEpExcelUtil;
import org.rcisoft.util.ExportToExcelUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import org.rcisoft.core.result.CyResult;
import org.rcisoft.core.util.CyResultGenUtil;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.constant.CyMessCons;
import org.rcisoft.core.controller.CyPaginationController;


import org.rcisoft.bus.jnsp7xtm.service.Jnsp7xtmService;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * Created by cy on 2024年4月16日 下午5:29:36.
 */
@RestController
@RequestMapping("/jnsp7xtm")
public class Jnsp7xtmController extends CyPaginationController<Map> {


    @Autowired
    private Jnsp7xtmService jnsp7xtmServiceImpl;

    @Autowired
    private Jnsp7xtmDtoService jnsp7xtmDtoService;

    @Autowired
    private ExportExcelService exportExcelService;

    // 导出用户信息
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出用户信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出用户信息", notes = "导出用户信息")
    @GetMapping(value = "/export")
    public void outJnsp7xtm(HttpServletResponse response, QueryJnsp7xtmDto jnsp7xtm, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        exportExcelService.outJnsp7xtmDetail(response,jnsp7xtm,excelName);
    }

    // 导出详细信息
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出详细信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出详细信息", notes = "导出详细信息")
    @PostMapping(value = "/outDetailsJnsp7xtm")
    public void outDetailsJnsp7xtm(HttpServletResponse response, @RequestBody RequestInfromationDto requestInfromationDto, @PathVariable @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        exportExcelService.outUserJnsp7xtmDetail(response,requestInfromationDto,excelName);
    }

    // 导出明细信息
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出明细信息", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出明细信息", notes = "导出明细信息")
    @GetMapping(value = "/outJnsp7xtmDetail")
    public void outJnsp7xtmDetail(HttpServletResponse response, QueryJnsp7xtmDto jnsp7xtm, @RequestParam(defaultValue = "0") String excelId) {
        String excelName = "";
        switch (excelId) {
            case "0":
                excelName = "Jnsp7xtm信息.xls";
                break;
            case "1":
                excelName = "Jnsp7xtm信息.xlsx";
                break;
            case "2":
                excelName = "Jnsp7xtm信息.csv";
                break;
        }
        exportExcelService.outJnsp7xtmDetail(response,jnsp7xtm,excelName);
    }

    // 导出统计
    @CyOpeLogAnno(title = "system-Jnsp7xtm管理-导出统计", businessType = CyLogTypeEnum.EXPORT)
    @ApiOperation(value = "导出统计", notes = "导出统计")
    @PostMapping(value = "/outTotalJnsp7xtm")
    public void outTotalJnsp7xtm(HttpServletResponse response, @RequestBody RequestDto requestDto) {
        //判断查询条件是否为全空
        boolean conditionIsNull =
                requestDto.isRmb() ||
                        requestDto.isXsjg() ||
                        requestDto.isCount() || requestDto.isChzs() || requestDto.isChzsa() || requestDto.isChzsb() || requestDto.isZzc() || requestDto.isZzcg();


        //没有选择默认选一个
        if (!conditionIsNull) {
            requestDto.setChzs(true);
        }
        ExportTotalDto exportTotalDto = jnsp7xtmServiceImpl.outTotalJnsp7xtm(requestDto);
        if (exportTotalDto.getDataList() != null && exportTotalDto.getEntityList() != null) {
            ExportToExcelUtil.exportExcel(response, exportTotalDto.getEntityList(), exportTotalDto.getDataList());
        } else {
            throw new CyServiceException("要导出数据为空");
        }
    }

    // 查询下拉框下拉数据
    @CyOpeLogAnno(title = "system-DemoData1管理-查询下拉框数据", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询下拉框数据", notes = "查询下拉框数据")
    @GetMapping("/selectOption")
    private CyResult selectOptionList() {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.searchOption());
    }
    @CyOpeLogAnno(title = "system-DemoData1管理-查询高级搜索", businessType = CyLogTypeEnum.OTHER)
    @ApiOperation(value = "查询高级搜索", notes = "查询高级搜索")
    @GetMapping("/searchHeightOption")
    private CyResult searchHeightOption() {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.searchHeightOption());
    }


    @PostMapping("/getListTotal")
    public CyResult getListTotal(@RequestBody RequestDto requestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.getListTotal(requestDto));
    }

    // 查询统计
    @PostMapping("/getList")
    public CyResult getList(@RequestBody RequestDto requestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.getList(requestDto));
    }

    // 求合计的个数
    @PostMapping("/getTotal")
    public CyResult getTotal(@RequestBody RequestDto requestDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.getTotal(requestDto));
    }

    @PostMapping("/getClickInformation")
    public CyResult getInformation(@RequestBody RequestInfromationDto requestInfromationDto) {

        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.getInformation(requestInfromationDto));
    }

    @PostMapping("/getClickInformationPageNum")
    public CyResult getClickInformationPageNum(@RequestBody RequestInfromationDto requestInfromationDto) {
        return CyResultGenUtil.builder(new CyPersistModel(1),
                CyMessCons.MESSAGE_ALERT_SUCCESS,
                CyMessCons.MESSAGE_ALERT_ERROR,
                jnsp7xtmServiceImpl.getClickInformationPageNum(requestInfromationDto));
    }


}
