package org.rcisoft.bus.jnsp7xtm.controller;

import io.swagger.annotations.ApiOperation;
import org.rcisoft.bus.jnsp7xtm.entity.Jnsp7xtmDto;
import org.rcisoft.bus.jnsp7xtm.service.Jnsp7xtmDtoService;
import org.rcisoft.bus.jnsp7xtm.vo.QueryJnsp7xtmDto;
import org.rcisoft.core.anno.CyOpeLogAnno;
import org.rcisoft.core.controller.CyPaginationController;
import org.rcisoft.core.model.CyGridModel;
import org.rcisoft.core.operlog.enums.CyLogTypeEnum;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

/**
 * @Author: gy
 * @Date: 2024/4/19 10:51
 * @Description:
 */
@RestController
@RequestMapping("/Jnsp7xtmDto")
public class Jnsp7xtmDtoController  extends CyPaginationController<Jnsp7xtmDto> {

    @Autowired
    private Jnsp7xtmDtoService jnsp7xtmDtoService;

    // 分页查询用户信息
    @CyOpeLogAnno(title = "system-入库记录管理-查询入库记录", businessType = CyLogTypeEnum.QUERY)
    @ApiOperation(value="分页查询入库记录集合", notes="分页查询入库记录集合")
    @GetMapping(value = "/queryUserDataByPagination")
    public CyGridModel listByPagination(QueryJnsp7xtmDto queryJnsp7xtmDto) {
        jnsp7xtmDtoService.findAllByPagination(getPaginationUtility(), queryJnsp7xtmDto);
        return getGridModelResponse();
    }
}
