package org.rcisoft.bus.jnsp7xtm.dao;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.apache.ibatis.annotations.Mapper;
import org.rcisoft.bus.jnsp7xtm.entity.*;
import org.rcisoft.bus.jnsp7xtm.vo.StatisticsDto;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.apache.ibatis.annotations.Param;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
* Created with cy on 2024年4月16日 下午5:29:36.
*/
@Mapper
public interface Jnsp7xtmRepository extends CyBaseMapper<Map> {

    // 下拉框查询
    List<RoleDto> searchNqy();

    List<RoleDto> searchKhdm();

    List<RoleDto> searchKhqf();

    List<RoleDto> searchMksqf();

    List<RoleDto> searchDdh();

    List<RoleDto> searchPn();

    List<RoleDto> searchKhm();

    // 分页查询rmb总和
    List<Map> getListrmb(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 分页查询chzsA和chzsB之和
    List<Map> getListchzs(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 不分页查询rmb总和
    List<Map<String,Object>> getExportListrmb(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询rmb个数
    List<Map<String,Object>> getExportListCountrmb(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询chzsa和chzsb之和
    List<Map<String,Object>> getExportListChzsaAndchzsb(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 获取要导出总条数
    List<Map<String,Object>> getExportListCount(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 分页查询chzsA
    List<Map> getListChzsaA(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 分页查询chzsB
    List<Map> getListChzsaB(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 分页查询zzc
    List<Map> getListzzc(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 分页查询zzcg
    List<Map> getListzzcg(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 不分页查询chzsa
    List<Map<String,Object>> getExportListChzsaA(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询chzsB
    List<Map<String,Object>> getExportListChzsaB(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询zzc
    List<Map<String,Object>> getExportListZzc(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询 zzcg
    List<Map<String,Object>> getExportListZzcg(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 分页查询xsjg
    List<Map> getListxsjg(@Param("entity") RequestDto requestDto, @Param("monthList") String months, @Param("pageNo") int pageNo, @Param("pageSize") int pageSize);

    // 不分页查询xsjg
    List<Map<String,Object>> getExportListxsjg(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 不分页查询xsjg的个数
    List<Map<String,Object>> getExportListCountxsjg(@Param("entity") RequestDto requestDto, @Param("monthList") String months);

    // 查询统计
    List<StatisticsDto> queryStatistics(@Param("entity") RequestDto requestDt);

    // 查询月份
    List<String> getMonths();

    // 分页查询jnsp7xtm详情信息 与统计无关
    List<RoleDto> getInformation(@Param("entity") RequestInfromationDto requestInfromationDto);

    // 与上个方法一样 只是不分页
    List<RoleDto> getAllInformation(@Param("entity") RequestInfromationDto requestInfromationDto);

    // 查询详情中总数
    Integer queryTotal(@Param("entity") RequestInfromationDto requestInfromationDto);

    // 分页查询jnsp7xtm详情信息
    IPage<RoleDto> pagingQueryAllInformation(IPage<RoleDto> page,@Param("entity") RequestInfromationDto requestInfromationDto );

    // 查询用户的个数
    String getClickInformationPageNum(@Param("entity") RequestInfromationDto requestInfromationDto);

    // 查询jlpm下拉数据
    List<String> jLpmOptionList();

    // 查询zd下拉数据
    List<String> zdOptionList();

    // 查询fnq下拉数据
    List<String> fnqOptionList();

    // 查询szzt下拉数据
    List<String> szztOptionList();

    // 查询数据库jnsp7xtm的记录的个数
    Integer queryNUmber();




}

